<?php

namespace Litecms\Practice;

use User;

class Practice
{
    /**
     * $practice object.
     */
    protected $practice;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Practice\Interfaces\PracticeRepositoryInterface $practice)
    {
        $this->practice = $practice;
    }

    /**
     * Returns count of practice.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.practice.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->practice->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\PracticeUserCriteria());
        }

        $practice = $this->practice->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('practice::' . $view, compact('practice'))->render();
    }
}
